Bug 613993 - Review Request: mingw32-celt051 - An audio codec for use in low-delay speech and audio communication
Review Request: mingw32-celt051 - An audio codec for use in low-delay speech ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Erik van Pienbroek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-13 09:02 EDT by Gerd Hoffmann
Modified: 2010-09-23 08:56 EDT (History)
5 users (show)

See Also:
Fixed In Version: mingw32-celt051-0.5.1.3-3.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-09-23 08:56:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
erik-fedora: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)
Patch which makes celt build as DLL on Win32 targets (569 bytes, patch)
2010-08-07 18:14 EDT, Erik van Pienbroek
no flags Details | Diff

  None (edit)
Description Gerd Hoffmann 2010-07-13 09:02:07 EDT
Spec URL: http://kraxel.fedorapeople.org/review/mingw32-celt051/mingw32-celt051.spec
SRPM URL: http://kraxel.fedorapeople.org/review/mingw32-celt051/mingw32-celt051-0.5.1.3-1.fc14.src.rpm
Packages: http://kraxel.fedorapeople.org/review/mingw32-celt051/
Description:
CELT (Constrained Energy Lapped Transform) is an ultra-low delay audio 
codec designed for realtime transmission of high quality speech and audio. 
This is meant to close the gap between traditional speech codecs 
(such as Speex) and traditional audio codecs (such as Vorbis).
Comment 1 Erik van Pienbroek 2010-07-25 17:33:48 EDT
$ rpmlint mingw32-celt051.spec 
mingw32-celt051.spec: W: no-cleaning-of-buildroot %install
mingw32-celt051.spec: W: no-cleaning-of-buildroot %clean
mingw32-celt051.spec: W: no-buildroot-tag
mingw32-celt051.spec: W: no-%clean-section
0 packages and 1 specfiles checked; 0 errors, 4 warnings.

- Please fix the rpmlint warnings mentioned above
- Please use %global instead of %define for all the macros at the top of the
.spec file
- Please add a comment about the purpose of the patch
- Please use 'make %{?_smp_mflags}' instead of just 'make'
- Please use a complete file list instead of %{_mingw32_libdir}/libcelt051* as the * masks the fact that only a static library is bundled
- Is it correct that this package only provides a static library and no shared library (DLL)? Shared libraries are preferred in Fedora. If shared libraries aren't supported by upstream (and upstream doesn't want to support this), please move all files to a -static subpackage and make the main package require the -static subpackage
Comment 2 Gerd Hoffmann 2010-08-03 12:55:34 EDT
The rpmlint warnings are bogous, this isn't needed with recent rpm versions (Fedora 13+).

This package builds both shared and static libraries with native linux builds and static libraries only on windows cross builds.  The configure output indicates it thinks libtool supports creating dlls.  No idea why it doesn't and whenever it is intentional or not.

The package guidelines about separate -static (and -devel) packages don't apply to mingw32-* packacges according to rjones.

Will fixup the other nits and upload new builds later today or tomorrow.
Comment 3 Gerd Hoffmann 2010-08-03 18:08:09 EDT
Updated packages and spec file uploaded to
http://kraxel.fedorapeople.org/review/mingw32-celt051/
Comment 4 Erik van Pienbroek 2010-08-07 18:14:31 EDT
Created attachment 437382 [details]
Patch which makes celt build as DLL on Win32 targets

(In reply to comment #2)
> This package builds both shared and static libraries with native linux builds
> and static libraries only on windows cross builds.  The configure output
> indicates it thinks libtool supports creating dlls.  No idea why it doesn't and
> whenever it is intentional or not.

I just took a quick look at it and here's the culprit:

libtool: link: warning: undefined symbols not allowed in i686-pc-mingw32 shared libraries

This is a common problem for mingw32 and there's also an easy fix to it (which doesn't have any side-effects for other platforms). I've attached a patch to this bugreport which fixes that problem. Feel free to propose it upstream.

With that patch applied, 2 new files show up in the file list:
%{_mingw32_bindir}/libcelt051-0.dll
%{_mingw32_libdir}/libcelt051.dll.a

Now that these files are visible, you can move the static .a library to a -static subpackage. This is also according to the MinGW packaging guidelines at http://fedoraproject.org/wiki/Packaging/MinGW#Static_libraries
 
> The package guidelines about separate -static (and -devel) packages don't apply
> to mingw32-* packacges according to rjones.

He's right about the -devel packages. As all mingw32 packages are only used for developers, there's no need for -devel subpackages. However, static libraries need to be put in a -static subpackage as it's recommended to use shared libraries instead of static libraries.
Comment 5 Gerd Hoffmann 2010-08-27 05:29:33 EDT
Finally found the time to continue this.  Uploaded new rev3 packages:
http://kraxel.fedorapeople.org/review/mingw32-celt051/

Build dlls using your patch.  Dropped the static libraries.
Comment 6 Erik van Pienbroek 2010-09-12 13:44:28 EDT
$ rpmlint mingw32-celt051.spec 
mingw32-celt051.spec: W: no-cleaning-of-buildroot %clean
mingw32-celt051.spec: W: no-buildroot-tag
mingw32-celt051.spec: W: no-%clean-section
0 packages and 1 specfiles checked; 0 errors, 3 warnings.

$ rpmlint mingw32-celt051-0.5.1.3-3.fc14.src.rpm 
mingw32-celt051.src: W: spelling-error Summary(en_US) codec -> cosec, codex, code
mingw32-celt051.src: W: spelling-error %description -l en_US codec -> cosec, codex, code
mingw32-celt051.src: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
mingw32-celt051.src: W: spelling-error %description -l en_US codecs -> codes, coders, code's
mingw32-celt051.src: W: no-cleaning-of-buildroot %clean
mingw32-celt051.src: W: no-buildroot-tag
mingw32-celt051.src: W: no-%clean-section
1 packages and 0 specfiles checked; 0 errors, 7 warnings.

$ rpmlint mingw32-celt051-0.5.1.3-3.fc14.noarch.rpm 
mingw32-celt051.noarch: W: spelling-error Summary(en_US) codec -> cosec, codex, code
mingw32-celt051.noarch: W: spelling-error %description -l en_US codec -> cosec, codex, code
mingw32-celt051.noarch: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
mingw32-celt051.noarch: W: spelling-error %description -l en_US codecs -> codes, coders, code's
1 packages and 0 specfiles checked; 0 errors, 4 warnings.

All these rpmlint warnings can be ignored

$ rpmquery --requires mingw32-celt051
pkgconfig  
mingw32-libogg  
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
mingw32-filesystem >= 57
mingw32-runtime  
mingw32(kernel32.dll)  
mingw32(libcelt051-0.dll)  
mingw32(libogg-0.dll)  
mingw32(msvcrt.dll)  
mingw32(user32.dll)  
rpmlib(PayloadIsXz) <= 5.2-1

$ rpmquery --provides mingw32-celt051
mingw32(libcelt051-0.dll)  
mingw32-celt051 = 0.5.1.3-3.fc14

$ rpmquery --fileprovide mingw32-celt051
/usr/i686-pc-mingw32/sys-root/mingw/bin/celtdec051.exe	
/usr/i686-pc-mingw32/sys-root/mingw/bin/celtenc051.exe	
/usr/i686-pc-mingw32/sys-root/mingw/bin/libcelt051-0.dll	
/usr/i686-pc-mingw32/sys-root/mingw/include/celt051	
/usr/i686-pc-mingw32/sys-root/mingw/include/celt051/celt.h	
/usr/i686-pc-mingw32/sys-root/mingw/include/celt051/celt_header.h	
/usr/i686-pc-mingw32/sys-root/mingw/include/celt051/celt_types.h	
/usr/i686-pc-mingw32/sys-root/mingw/lib/libcelt051.dll.a	
/usr/i686-pc-mingw32/sys-root/mingw/lib/libcelt051.la	
/usr/i686-pc-mingw32/sys-root/mingw/lib/pkgconfig/celt051.pc	
/usr/share/doc/mingw32-celt051-0.5.1.3	
/usr/share/doc/mingw32-celt051-0.5.1.3/COPYING	
/usr/share/doc/mingw32-celt051-0.5.1.3/README	
/usr/share/doc/mingw32-celt051-0.5.1.3/TODO	


$ curl http://downloads.us.xiph.org/releases/celt/celt-0.5.1.3.tar.gz | md5sum
  % Total    % Received % Xferd  Average Speed   Time    Time     Time  Current
                                 Dload  Upload   Total   Spent    Left  Speed
100  430k  100  430k    0     0   176k      0  0:00:02  0:00:02 --:--:--  308k
67e7b5e45db57a6f1f0a6962f5ecb190  -
$ md5sum celt-0.5.1.3.tar.gz 
67e7b5e45db57a6f1f0a6962f5ecb190  celt-0.5.1.3.tar.gz


Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=2463137


+ OK
! Needs to be looked into
/ Not applicable
* Overridden by MinGW guidelines

[+] Files are installed in /usr/i686-pc-mingw32/sys-root/mingw
[+] BuildRequires: mingw32-filesystem >= xx is in the .spec file
[+] Requires are OK
[+] BuildArch: noarch
[+] No man pages or info files
[+] default strip and objdump commands are overridden with mingw32 specific ones


[+] rpmlint must be run on every package. The output should be posted in the review
[+] MUST: The package must be named according to the Package Naming Guidelines
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines
[+] MUST: The package must meet the Packaging Guidelines
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[/] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as BuildRequires is optional.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[*] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
[+] MUST: The package must contain code, or permissable content.
[/] MUST: Large documentation files should go in a -doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[*] MUST: Header files must be in a -devel package.
[/] MUST: Static libraries must be in a -static package.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[*] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[*] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[*] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[*] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.


=====================================================
 The package mingw32-celt051 is APPROVED by epienbro 
=====================================================

PS. Could you please review mingw32-gdk-pixbuf in return? It's required to build the latest ming32-gtk2. https://bugzilla.redhat.com/show_bug.cgi?id=633058
Comment 7 Gerd Hoffmann 2010-09-16 07:55:47 EDT
New Package SCM Request
=======================
Package Name: mingw32-celt051
Short Description: An audio codec for use in low-delay speech and audio communication
Owners: kraxel
Branches: f14
InitialCC:
Comment 8 Kevin Fenzi 2010-09-16 18:55:29 EDT
Git done (by process-git-requests).
Comment 9 Fedora Update System 2010-09-17 07:13:44 EDT
mingw32-celt051-0.5.1.3-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/mingw32-celt051-0.5.1.3-3.fc14
Comment 10 Fedora Update System 2010-09-23 08:56:47 EDT
mingw32-celt051-0.5.1.3-3.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.